% Second example in the manual:

% Example illustrating the difference between
% forward and reverse accumulation:

% Sample execution:
% | ?- flist(10, [], List).
% 
% List = [1,2,3,4,5,6,7,8,9,10]
% 
% yes
% | ?- rlist(10, List, []).
% 
% List = [10,9,8,7,6,5,4,3,2,1]
% 
% yes
% | ?-

% Declare the accumulators:
:-acc info(fwd, T, In, Out, Out=[T|In]).   % Forward accumulator.
:-acc info(rev, T, Out, In, Out=[T|In]).   % Reverse accumulator.

% Declare the predicates using them:
:-pred info(flist, 1, [fwd]).
:-pred info(rlist, 1, [rev]).

% flist(N, [], List) creates the list [1, 2, ..., N]
flist(0) -->> [].
flist(N) -->> N>0, [N]:fwd, N1 is N-1, flist(N1).

% rlist(N, List, []) creates the list [N, ..., 2, 1]
rlist(0) -->> [].
rlist(N) -->> N>0, [N]:rev, N1 is N-1, rlist(N1).

go:-flist(10, [], List),write(List),nl,fail
; rlist(10, List, []),write(List),nl.

/*
?- reconsult(e2).
% using compile/1 is MUCH faster
consulting(e2.pl)
consulted(e2.pl,time = 40)
yes
?- go.
[1,2,3,4,5,6,7,8,9,10]
[10,9,8,7,6,5,4,3,2,1]
yes
?- listing.
go :- 
        (   flist(10,[],A),
                write(A),
                nl,
                fail
        ;   rlist(10,A,[]),
                write(A),
                nl
        ).

rlist(0,A,A).
rlist(A,B,C) :- 
        A > 0,
        B = [A|D],
        true,
        E is A-1,
        rlist(E,D,C).

flist(0,A,A).
flist(A,B,C) :- 
        A > 0,
        D = [A|B],
        true,
        E is A-1,
        flist(E,D,C).


yes
*/
