#
# This script generates a directory browser, which lists the working
# directory and allows you to open files or subdirectories by
# double-clicking.

# Create a scrollbar on the right side of the main window and a listbox
# on the left side.

# The procedure below is invoked to open an editor on a given file;  if
# the file is a regular file then the emacs editor is invoked to display
# the file.

global action editor
set action edit
set editor textedit

proc compile {file} {
  p "compile('$file')"
}

proc edit {file} {
    global env editor
    if [file isfile $file] { 
	    if [info exists env(EDITOR)] {
		set editor $env(EDITOR)
            exec $editor $file &
	    }
     } else {
	    puts stdout "\"$file\" isn't a directory or regular file"
     }
}

proc init {} {

# make the box
  scrollbar .scroll -command ".list yview"
  pack .scroll -side right -fill y
  listbox .list -yscroll ".scroll set" -relief raised -geometry 20x20 \
	-setgrid yes
  pack .list -side left -fill both -expand yes
  wm minsize . 1 1

# Set up bindings for the browser.

  bind .list <Control-q> {destroy .}
  bind .list <Control-c> {destroy .}
  focus .list
  bind .list <Double-Button-1> {foreach i [selection get] { $action $i } }
}

# Fill the listbox with a list of all the files in the directory

proc refresh {} {
  .list delete 0 end
  foreach i [exec ls -a] {
    if [file isfile $i] {
      .list insert end $i
   }
  }
}

# change the action dynamically

proc e {} {
   global action
   set action edit
}

proc c {} {
   global action
   set action compile
}

source server.tcl
start_prolog
init
refresh
