proc car {l} {
  return [lindex $l 0]
}

proc cdr {l} {
  return [lrange $l 1 end]
}

proc empty {l} {
 return [expr 0 == [string compare {} $l]]
}

proc cons {l r} {
  return [concat [list $l] $r]  
}

proc app {l r} {
  if {[empty $l]} {
    return $r
  } else {
    return [cons [car $l] [app [cdr $l] $r]]
  }
}

proc nrev {l} {
  if {[empty $l]} {
     return $l
  } else {
    return [app [nrev [cdr $l]] [cons [car $l] {}]]
  }
}

proc ints {min max} {
  if {$min > $max} {
    return {}
  } else {
    return [cons $min [ints [expr $min + 1] $max]]
  }
}

proc go {n} {
  set ms 1000000.0
  set l [ints 1 $n]
  set r [time [list nrev $l]]
  set t [car $r]
  set infs [expr ($n + 1.0) * ($n + 2.0) / 2.0] 
  set lips [expr ($infs * $ms) / $t ]
  return "length=$n, time=[expr $t / $ms], lips=$lips" 
}
