global n w scale count

proc make_board {{w .p1} name} {
    global scale n
    set s [expr $n * 40]
    catch {destroy $w}
    toplevel $w
    wm title $w $name
    wm iconname $w $name

    message $w.msg \
	-font -Adobe-times-medium-r-normal--*-180* -aspect 300 \
	-text $name
    frame $w.frame \
	-geometry [format "%dx%d" $s $s] \
        -borderwidth 2 -relief sunken \
	-bg Bisque3

    button $w.start \
	-text START \
	-command "p qs($n); set count 0"
    button $w.more \
	-text MORE \
	-command {p more; $w.more configure -text MORE($count)}
    button $w.ok \
	-text OK \
	-command "p done; destroy $w; q nl"

    pack $w.msg \
	-side top
    pack $w.frame \
	-side top \
	-padx 5 \
	-pady 5

    pack $w.ok -side bottom -fill x
    pack $w.more -side bottom -fill x
    pack $w.start -side bottom -fill x

    for {set i 0} {$i < $n} {set i [expr $i+1]} {
      for {set j 0} {$j < $n} {set j [expr $j+1]} {
	set ypos($i) [expr $i*$scale]
	set xpos($j) [expr $j*$scale]
	button $w.frame.q($i,$j) \
            -relief sunken  \
	    -command  "flip_queen $w $i $j"
	place $w.frame.q($i,$j) \
            -rely $ypos($i) -relx $xpos($j) \
	    -relwidth $scale -relheight $scale
      }
    }
}

proc show_queen {w i j} {
  $w.frame.q($i,$j) configure -relief raised -text Q
}

proc hide_queen {w i j} {
  $w.frame.q($i,$j) configure -relief sunken -text ""
}

proc hide_queens {} {
  global n w
    for {set i 0} {$i < $n} {set i [expr $i+1]} {
      for {set j 0} {$j < $n} {set j [expr $j+1]} {
        hide_queen $w $i $j
      }
    }
}

proc eq {s t} {
  return [expr 0 == [string compare $s $t]]
}

proc flip_queen {w i j} {
 set s [lindex [$w.frame.q($i,$j) config -text] 4]
 if {[eq $s "Q"]} {
   hide_queen $w $i $j
 } else {
   show_queen $w $i $j
 }
}

proc display_queens {qs} {
  global w count
  incr count
  hide_queens
  set l 0
  foreach q $qs {
    incr l
    show_queen $w [expr $l -1] [expr $q -1]    
  }  
}

proc go {queens} {
  global w n scale count
  set n $queens
  set w .b
  set count 0
  set scale [expr 1.0/$n]
  make_board $w $n-Queens
}

source server.tcl
start_prolog
p {compile(queens)}

go 8
