# mkVScale w
#
# Create a top-level window that displays a vertical scale.
#

proc mkVScale {{w .scale1}} {
    catch {destroy $w}
    toplevel $w
    wm title $w "BinProlog-Tcl/Tk -DEMO-"
    wm iconname $w "NrevScale"
    message $w.msg -font -Adobe-times-medium-r-normal--*-180* -aspect 400 \
	    -text {
Heap consumption of BinProlog for nrev/2.
Send the length of the list, BinProlog will
adjust the scale to the size of the consumed
heap in KBytes.
Click on DEMO for a random interaction.
Click on OK to finish.
}
    frame $w.frame -borderwidth 10
    button $w.send -text SEND -command {
      set l [.sc.frame.scale get]
      p "mesure_heap($l)"
      }
    button $w.demo -text DEMO -command {
      p "mesure_heap"
      }
    button $w.ok -text OK -command "destroy $w"

    pack $w.msg $w.frame $w.send $w.demo $w.ok

    scale $w.frame.scale -orient vertical -length 350 -from 0 -to 220 \
	    -command "setHeight $w.frame.right.inner" -tickinterval 50 \
	    -bg Bisque1
    frame $w.frame.right -borderwidth 15
    pack $w.frame.scale -side left -anchor ne
    pack $w.frame.right -side left -anchor nw
    $w.frame.scale set 30

    frame $w.frame.right.inner -geometry 40x20 -relief raised \
	    -borderwidth 2 -bg SteelBlue1
    pack $w.frame.right.inner -expand yes -anchor nw
}

proc setHeight {w height} {
    $w config -geometry 40x${height}
}

proc make_scale {} {
  mkVScale .sc
}

make_scale
source server.tcl
start_prolog
p {compile(scale)}
