# This program can be used to split a unique TCL+Prolog+TeX + whatever
# file in multiple files with parts in the same language merged
# don't expect too much from it, as it is my first tcl program...
#
#  An example file looks like this:
#  >>>.pl
#  ....
#  >>>.tcl
#  ....
#  >>>.pl
#  ....
# A reverse join operation is also supported.

global mark
set mark ">>>."

# detects a hint >>> NewFile
proc is_new_file {l} {
  global mark
  set is_new [expr 0 == [string first $mark [ string trim $l]]]
  return $is_new
}

# extracts "NewFile" from ">>>NewFile"
proc file_ext {l} {
  global mark
  set name [string range [string trim $l] [string length $mark] end]
  return [string trim $name]
}

# splits a source file in various different programs
proc split_file {fname} {
  global mark
  set f [open $fname r]
  catch {eval exec rm [glob $fname.*]}
  gets $f l
  if {0 == [is_new_file $l]} {
    return "Expected $mark FILE_EXTENSION, found $l"
  }
  set ext [file_ext $l]
  set g [open "$fname.$ext" a+]

  while {[gets $f l] >= 0} {
    if {0 != [is_new_file $l]} {
       close $g
       set ext [file_ext $l]
       set g [open "$fname.$ext" a+]
    } else {
      puts $g $l
    }
  }
  close $g
  close $f
}

# joins <file>.<extension> into <file> with annotations for each part
proc join_file {fname} {
  set l [glob $fname.*]
  catch {exec rm $fname}
  exec touch $fname
  foreach i $l {
    set r [string range $i [expr [string length $fname] + 1] end]
    set j ">>>$r\n"
    exec cat << $j >> $fname
    exec cat $i >> $fname
  }
}
