% ---------- ADD BUILTINS: <here> and in wam.c -----------------------

n_inline(51).                         % INLINE starts here
n_arith(X1):-n_inline(X),X1 is X+9.  % number of arith --> #change!
n_bu(X1):-n_arith(X),X1 is X+44. % number of in_body -> #change!
n_nop(X1):-n_bu(X),X1 is X+16.  % number of in_head -> #change

% #change USE FIND WITH YOUR EDITOR

bu(fail(_),0,in_body).
bu(cwrite(_,_),1,in_body).
bu(nl(_),2,in_body).
bu(var(_,_),3,in_body).
bu(nonvar(_,_),4,in_body).
bu(integer(_,_),5,in_body).
bu(atomic(_,_),6,in_body).
bu(is_compiled(_,_),7,in_body).
bu(lift_heap(_),8,in_body).

% #change 9

bu(+(_,_,_,_),arith(0,1),in_body).
bu(-(_,_,_,_),arith(1,1),in_body).
bu(*(_,_,_,_),arith(2,1),in_body).
bu('/'(_,_,_,_),arith(3,1),in_body).
bu(mod(_,_,_,_),arith(4,1),in_body).
bu(random(_,_),arith(5,1),in_body).
bu(get0(_,_),arith(6,1),in_body).

bu(put(_,_),arith(7,0),in_body).

bu(less(_,_,_),arith(8,0),in_body).
bu(greater(_,_,_),arith(9,0),in_body).
bu(less_eq(_,_,_),arith(10,0),in_body).
bu(greater_eq(_,_,_),arith(11,0),in_body).
bu(arith_eq(_,_,_),arith(12,0),in_body).
bu(arith_dif(_,_,_),arith(13,0),in_body).

bu('<<'(_,_,_,_),arith(14,1),in_body).
bu('>>'(_,_,_,_),arith(15,1),in_body).
bu('/\'(_,_,_,_),arith(16,1),in_body).
bu('\/'(_,_,_,_),arith(17,1),in_body).
bu('#'(_,_,_,_),arith(18,1),in_body). % xor
bu('\'(_,_,_,_),arith(19,1),in_body). % complement

bu('compare0'(_,_,_,_),arith(20,1),in_body).
bu(arg(_,_,_,_),arith(21,1),in_body).

bu(def(_,_,_,_),arith(22,0),in_body).
bu(set(_,_,_,_),arith(23,0),in_body).
bu(val(_,_,_,_),arith(24,1),in_body).
bu(rm(_,_,_),arith(25,0),in_body).

bu(symcat(_,_,_,_),arith(26,1),in_body).
bu(copy_term(_,_,_,_),arith(27,1),in_body).

bu(seeing_telling(_,_,_),arith(28,1),in_body). % seeing=0,telling=1
bu(see_tell(_,_,_),arith(29,0),in_body). % see=0,tell=1
bu(seen_told(_,_),arith(30,0),in_body). % seen=0,told=1,flush=2

bu(det_append(_,_,_,_),arith(31,1),in_body).

bu(string_op(_,_,_,_),arith(32,1),in_body). % sread=0, swrite=1

bu(op0(_,_,_,_),arith(33,0),in_body). 

bu(lval(_,_,_,_),arith(34,1),in_body).
bu(termcat(_,_,_,_),arith(35,1),in_body).
bu(float_fun2(_,_,_,_,_),arith(36,1),in_body).
bu(float_fun(_,_,_,_),arith(37,1),in_body).
bu(input_float(_,_,_ ,_,_),arith(38,1),in_body).
bu(write_float(_,_),arith(39,0),in_body).
bu('//'(_,_,_,_),arith(40,1),in_body).
bu(halt(_,_),arith(41,0),in_body).
bu(add_instr(_,_,_,_,_),arith(42,0),in_body).
bu(new_builtin(_,_,_,_),arith(43,1),in_body). % arity 3+1 by binarization
% #change: 44

bu(true(_),0,in_head).
bu(call(_,_),1,in_head).

bu(findall_store_heap(_,_),2,in_head).
bu(findall_load_heap(_,_),3,in_head).

bu(functor(_,_,_,_),4,in_head).
bu(name(_,_,_),5,in_head).

bu(abort(_),6,in_head).
bu(restart(_),7,in_head).

bu(shell(_,_),8,in_head).

bu(stat0(_,_,_,_),9,in_head).

bu(list_asm(_,_,_,_),10,in_head).
bu(bboard(_,_,_),11,in_head).
bu(bb_list(_,_,_),12,in_head).
bu(bb_reset(_),13,in_head).
bu(profile(_),14,in_head).

bu(if0(_,_,_,_),15,in_head).

% #change 16

is_builtin(F/N1):-bu(T,_,_),functor(T,F,N),N1 is N-1.

stat_dict(runtime,0).
stat_dict(global_stack,1).
stat_dict(local_stack,2).
stat_dict(trail,3).
stat_dict(code,4).
stat_dict(strings,5).
stat_dict(symbols,6).
stat_dict(htable,7).
stat_dict(bboard,8).

errmes(Mes,Obj):-
	telling(F),
	tell(user),
	  write('*** '),write(Mes),write(': '),nl,
	  portray_clause(Obj),
	tell(F),
	fail.

user_error(Mes,Obj):-
	telling(F),
	tell(user),
	  cwrite('>>> '),cwrite(Mes),cwrite(': '),cwrite(Obj),nl,
	tell(F),
	fail.

member(C,[C|_]).
member(C,[_|L]):- member(C,L).

append([],Ys,Ys).
append([A|Xs],Ys,[A|Zs]):-
	append(Xs,Ys,Zs).
