% TOPLEVEL
main(X):-toplevel(X).

toplevel(bye):-
%	interactive(no),
	repeat,
    		topstep('?- '),
	!.

topstep(Prompt):-
	ttyprin(Prompt),
	ttyin(read_term(Body,Vs)),
	topinterp(Body,Vs).

topinterp(Goal,_):-var(Goal),!,errmes(should_be_nonvar,Goal).
topinterp(end_of_file,_):-!.
topinterp(Goal,Vs):-
	report_answers(Vs,Goal),
	fail.

report_answers([],Goal):-metacall(Goal),!,
	ttyprint(yes).
report_answers([V|Vs],Goal):-
	metacall(Goal),
	report_one_var(V),report_top_vars(Vs),
	another_sol(Ok),
        ( Ok=no->!,ttyprint(yes)
	; fail
	).
report_answers(_,_):-
	ttyprint(no).

	
report_top_vars(Eqs):-
	member(Eq,Eqs),
	ttyprint(','),report_one_var(Eq),
	fail.
report_top_vars(_).

report_one_var(V=E):-
	ttyprin(V),ttyprin(=),ttyout(writeq(E)).

another_sol(Ok):-
	is_interactive,!,
	ttyin(get0(A)),user_action(A,Ok),ttynl.
another_sol(yes):-ttyprint(';'),ttynl.

user_action(10,no):-!.
user_action(59,yes):-!,get0(10).
user_action(_,Ok):-ttyprin(' ; for more, <return> otherwise '),
  get0(10),get0(U),user_action(U,Ok).

